<template>
  <q-page class="q-pl-md bg-grey-1 splitscreen" role="presentation">
    <q-splitter class="splitscreen__splitter" v-model="panelWidth" :limits="[50,100]">
      <template v-slot:before>
        <div v-if="hypercube" role="region" aria-label="Definition detail">
          <DefinitionLinkDetailCard
            :hypercube="hypercube"
            :nt_version="nt_version"
            :dts_name="dts_name"
            v-on:conceptClicked="concept_clicked"
            v-on:nodeClicked="show_node"
            v-on:dim_conceptClicked="dim_concept_clicked"></DefinitionLinkDetailCard>
        </div>
      </template>

      <template v-slot:separator>
      </template>

      <template v-slot:after>
        <div v-if="line_item" role="region" aria-label="Detail geklikte cell">
          <CellValue :node="line_item" v-on:close_detail="close_detail"></CellValue>
        </div>
      </template>

    </q-splitter>
  </q-page>
</template>

<script>
import {api} from 'boot/axios'
import DefinitionLinkDetailCard from "./DefinitionLinkDetailCard";
import _ from "lodash"
import CellValue from "components/CellValue";

export default {
  name: "DefinitionLinkDetail",
  components: {CellValue, DefinitionLinkDetailCard},
  props: {
    hc_role_uri: String,
    dts_name: String,
    nt_version: String
  },
  computed() {
    lines: {
      return this.hypercube.line_items
    }
  },
  data() {
    return {
      hypercube: Object,
      panelWidth: 100,
      line_item: undefined
    }
  },
  mounted() {
    this.fetchData()
  },
  watch: {
    hc_role_uri: function () {
      this.fetchData()
    }
  },
  methods: {
    fetchData: function () {
      if (!_.isUndefined(this.dts_name)) {
        api
          .get("/dts/" + this.dts_name + "/hypercubes/" + this.hc_role_uri, {
            params: {
              nt_version: this.nt_version,
              full: 1
            }
          })
          .then(response => {
            this.hypercube = response.data[0]
            let scrollscreen = document.getElementsByClassName("q-splitter__before")[0]
            if (scrollscreen) {
              scrollscreen.scrollTop = 0
            }
          })
      }
    },
    close_detail: function () {
      this.panelWidth = 100
    },
    dim_concept_clicked: function (concept) {
      if (concept) {
        this.line_item = {concept: concept}
        if (this.panelWidth === 100) {
          this.panelWidth = 75
        }
      }
    },
    show_node: function(node) {
      this.line_item = node
        if (this.panelWidth === 100) {
          this.panelWidth = 75
        }
      return node
    },
    concept_clicked: function (concept_id) {
      function getConcept(items, concept_id) {
        let result = ""
        items.forEach(function (item) {
          if (item.concept_id === concept_id) {
            result = item
          } else {
            if (item.line_items) {
              result = getConcept(item.line_items, concept_id)
            }
          }
        })
        return result
      }

      let line_item = getConcept(this.hypercube.line_items, concept_id)
      if (line_item) {
        this.line_item = line_item
        if (this.panelWidth === 100) {
          this.panelWidth = 75
        }
      }
    }
  }
}
</script>

<style scoped>
.show_hide {
  position: sticky;
  top: 130px;
}

.splitscreen__splitter {
  height: calc(100vh - 150px);
  width: 98%;
}
</style>
